
* CSYSTEMS

#include "dcdir.ch"
#include "dctree.ch"
#include "dcdialog.ch"
#include "appevent.ch"
#include "xbp.ch"

#include "common.ch"
#include "test1.ch"


PROCEDURE AppSys()
RETURN

***************************
PROCEDURE Main()
***************************
      XSample_93()
RETURN




***************************
FUNCTION XSample_93()        // Roger Donnay
***************************
/*
This example shows how to use the DCTREEROOT and DCTREEITEM
commands to build a tree menu system.
*/

LOCAL GetList := {}, oMenu, oFileMenu, oPrintMenu, oEditMenu, ;
      cDocument := Space(60), cMemo := '', oMemo, oStatic1,  ;
      oStatic2, oMsgBox, ;
      lDocLoaded := .f., lDocSaved := .f.

LOCAL cSaveDir := DC_CurPath()

@ 1,4 DCSAY 'MENU' SAYSIZE 0 FONT '10.Verdana Bold'

@ 2,1 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT SIZE 25,11 OBJECT oStatic1 // FONT '10.Arial Bold'

@ 0,0 DCTREEROOT SIZE 25,11 OBJECT oMenu ;
  HASLINES HASBUTTONS PARENT oStatic1 ;
  ALWAYSSHOWSELECTION ;
  TOOLTIP 'Double-Click a main-menu item to expand/collapse sub-menu;' + ;
          'Double-Click a sub-menu item to select' ;
  EVAL {|o|o:keyboard := {|a,b,o|_TreeKeyboard(a,b,o,GetList)} }

DCTREEITEM CAPTION 'File' PARENT oMenu OBJECT oFileMenu ;
     MESSAGE 'These are File Options' INTO oMsgBox ;
     IMAGENORMAL ICON_CLOSEDFOLDER ;
     IMAGEMARKED ICON_CLOSEDFOLDER ;
     IMAGEEXPANDED ICON_OPENFOLDER

  DCTREEITEM CAPTION 'Load a Document' PARENT oFileMenu ;
     ACTION {||lDocLoaded := .t., lDocSaved := .f., ;
               _XSample_93(1,oMemo,@cDocument,@cMemo,GetList)} ;
     MESSAGE 'This will load a text file into the document Window' ;
       INTO oMsgBox ;
     IMAGENORMAL ICON_LOAD ;
     IMAGEMARKED ICON_LOAD ;
     IMAGEEXPANDED ICON_LOAD ;
     IMAGECHECKED ICON_CHECKED ;
     CHECKWHEN {||lDocLoaded} ;

  DCTREEITEM CAPTION 'Save Document' PARENT oFileMenu ;
     ACTION {||lDocSaved := .t., lDocLoaded := .f., ;
               _XSample_93(2,oMemo,@cDocument,@cMemo,GetList)} ;
     MESSAGE 'This will save the document in the Window to the text file' ;
       INTO oMsgBox ;
     IMAGENORMAL ICON_SAVE ;
     IMAGEMARKED ICON_SAVE ;
     IMAGEEXPANDED ICON_SAVE ;
     IMAGECHECKED ICON_CHECKED ;
     CHECKWHEN {||lDocSaved} ;

DCTREEITEM CAPTION 'Print' PARENT oMenu OBJECT oPrintMenu ;
     MESSAGE 'These are Printing Options' INTO oMsgBox ;
     IMAGENORMAL ICON_CLOSEDFOLDER ;
     IMAGEMARKED ICON_CLOSEDFOLDER ;
     IMAGEEXPANDED ICON_OPENFOLDER


  DCTREEITEM CAPTION 'Preview File' PARENT oPrintMenu ;
     ACTION {||_XSample_93(3,oMemo,@cDocument,@cMemo,GetList)} ;
     MESSAGE 'This will display a text file in a Preview Window' ;
       INTO oMsgBox ;
     IMAGENORMAL ICON_NAOCARE ;
     IMAGEMARKED ICON_NAOCARE ;
     IMAGEEXPANDED ICON_NAOCARE ;
     IMAGECHECKED ICON_QUESTION ;

  DCTREEITEM CAPTION 'Print File' PARENT oPrintMenu ;
     ACTION {||_XSample_93(4,oMemo,@cDocument,@cMemo,GetList)} ;
     MESSAGE 'This will Print a text file' INTO oMsgBox ;
     IMAGENORMAL ICON_PRINTER ;
     IMAGEMARKED ICON_PRINTER ;
     IMAGEEXPANDED ICON_PRINTER ;
     IMAGECHECKED ICON_QUESTION

DCTREEITEM CAPTION 'Edit' PARENT oMenu OBJECT oEditMenu ;
     MESSAGE 'These are Editing Options' INTO oMsgBox  ;
     IMAGENORMAL ICON_CLOSEDFOLDER ;
     IMAGEMARKED ICON_CLOSEDFOLDER ;
     IMAGEEXPANDED ICON_OPENFOLDER

  DCTREEITEM CAPTION 'Edit Document' PARENT oEditMenu ;
     ACTION {||_XSample_93(5,oMemo,@cDocument,@cMemo,GetList)} ;
     MESSAGE 'This will allow a loaded document to be edited' ;
       INTO oMsgBox ;
     IMAGENORMAL ICON_EDIT ;
     IMAGEMARKED ICON_EDIT ;
     IMAGEEXPANDED ICON_EDIT

  DCTREEITEM CAPTION 'Check Spelling' PARENT oEditMenu ;
     ACTION {||_XSample_93(6,oMemo,@cDocument,@cMemo,GetList)} ;
     MESSAGE 'This will check spelling (only if you have sufficient funds)' ;
       INTO oMsgBox ;
     IMAGENORMAL ICON_TRAZI ;
     IMAGEMARKED ICON_TRAZI ;
     IMAGEEXPANDED ICON_TRAZI

  DCTREEITEM CAPTION 'Clean Slate' PARENT oEditMenu ;
     ACTION {||_XSample_93(7,oMemo,@cDocument,@cMemo,GetList)} ;
     MESSAGE 'This will clear the document editor window' ;
       INTO oMsgBox ;
     IMAGENORMAL ICON_BRISI ;
     IMAGEMARKED ICON_BRISI ;
     IMAGEEXPANDED ICON_BRISI

DCTREEITEM CAPTION 'Exit Program' PARENT oMenu ;
   ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
   MESSAGE 'This will exit the program' INTO oMsgBox ;
     IMAGENORMAL ICON_OX ;
     IMAGEMARKED ICON_OX ;
     IMAGEEXPANDED ICON_OX



@ 1,32 DCSAY 'DOCUMENT' SAYSIZE 0 FONT '10.Verdana Bold'

@ 2,32 DCMULTILINE cMemo SIZE 60,12 OBJECT oMemo READONLY ;
  MESSAGE 'Edit your text in this Window' INTO oMsgBox

@ 14,1 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX SIZE 90,1.2 ;
   OBJECT oStatic2

@ .1,2 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT SIZE 87,1 PARENT oStatic2 ;
   OBJECT oMsgBox COLOR GRA_CLR_DARKRED //FONT '10.Courier New Bold'


DCGETOPTION FONT "8.Verdana" AUTORESIZE

DCREAD GUI FIT ADDBUTTONS MODAL OPTIONS GetOptions ;
   TITLE 'Tree Menu 2' ;
   EVAL {|o|SetAppWindow(o),oMemo:setData('COBA Systems Software'),SetAppFocus(oMenu)}

DC_ChDir(cSaveDir)

RETURN nil



***********************************************************************
STATIC FUNCTION _XSample_93( nMode, oMemo, cDocument, cMemo, aGetList )
***********************************************************************

LOCAL oDirs, oFiles, cDirectory, lOk, GetList := {}, oFileName

IF nMode = 1 // Open file

  @ 5,2 DCSAY 'Naziv TXT ili DOC fajla:'
  @ 6,2 DCGET cDocument GETSIZE 60 GETOBJECT oFileName
  @ 7.5,2 DCDIRTREE ;
      DIRS oDirs VAR cDirectory ;
      FILES oFiles VAR cDocument ;
      DATALINK {||oFileName:SetData(), DC_GetRefresh(GetList)} ;
      SIZE 60,10 ;
      EXT '*.*','*.TXT','*.DOC'

  DCGETOPTION FONT "8.Verdana" NORESIZE
  DCREAD GUI FIT ADDBUTTONS TO lOk MODAL OPTIONS GetOptions

  IF lOk
    cMemo := MemoRead(cDocument)
    oMemo:setData()
  ENDIF

ELSEIF nMode = 2  // Save file

  cMemo := oMemo:GetData()
  MemoWrit(cDocument,cMemo)

ELSEIF nMode = 3  // Preview file

  DC_PrintFile(cDocument,.t.)

ELSEIF nMode = 4  // Print file

  DC_PrintFile(cDocument,.f.)

ELSEIF nMode = 5  // edit

  oMemo:setEditable(.t.)
  SetAppFocus(oMemo)

ELSEIF nMode = 6 // check spelling

  DC_Winalert('Provera gotova')

ELSEIF nMode = 7

  cMemo := ' '
  oMemo:setData()

ENDIF

DC_GetRefresh(aGetList)

RETURN nil





***************************************************************
STATIC FUNCTION _TreeKeyboard( mp1, mp2, oTreeRoot, aGetList )
***************************************************************

LOCAL oItem, bAction

IF mp1 == xbeK_ENTER
  oItem := oTreeRoot:getData()
  bAction := DC_GetBlock(aGetList[oItem:cargo[1],bGETLIST_ACTION])
  IF Valtype(bAction) = 'B'
    Eval(bAction,oItem)
  ELSEIF oItem:isExpanded()
    oItem:expand(.f.)
  ELSE
    oItem:expand(.t.)
  ENDIF
ENDIF

RETURN nil
